crypton-0.33: Cryptography Primitives sink

License | BSD-style
Maintainer | Vincent Hanquez <vincent@snarc.org>
Stability | experimental
Portability | Good
Safe Haskell | Safe-Inferred
Language | Haskell2010

Crypto.PubKey.RSA

Contents

- Generation function

Description

Synopsis

- data Error
  - = MessageSizeIncorrect
  - | MessageTooLong
  - | MessageNotRecognized
  - | SignatureTooLong
  - | InvalidParameters
- data PublicKey = PublicKey {
  - public_size :: Int
  - public_n :: Integer
  - public_e :: Integer
  }
- data PrivateKey = PrivateKey {
  - private_pub :: PublicKey
  - private_d :: Integer
  - private_p :: Integer
  - private_q :: Integer
  - private_dP :: Integer
  - private_dQ :: Integer
  - private_qinv :: Integer
  }
- data Blinder = Blinder !Integer !Integer
- generateWith :: (Integer, Integer) -> Int -> Integer -> Maybe (PublicKey, PrivateKey)
- generate :: MonadRandom m => Int -> Integer -> m (PublicKey, PrivateKey)
- generateBlinder :: MonadRandom m => Integer -> m Blinder

# Documentation

data Error Source #

error possible during encryption, decryption or signing.

Constructors

MessageSizeIncorrect | the message to decrypt is not of the correct size (need to be == private_size)
MessageTooLong | the message to encrypt is too long
MessageNotRecognized | the message decrypted doesn't have a PKCS15 structure (0 2 .. 0 msg)
SignatureTooLong | the message's digest is too long
InvalidParameters | some parameters lead to breaking assumptions.

#### Instances

Instances details

Show Error Source # |
Instance details Defined in Crypto.PubKey.RSA.Types Methods showsPrec :: Int -> Error -> ShowS Source # show :: Error -> String Source # showList :: [Error] -> ShowS Source #
Eq Error Source # |
Instance details Defined in Crypto.PubKey.RSA.Types Methods (==) :: Error -> Error -> Bool Source # (/=) :: Error -> Error -> Bool Source #

data PublicKey Source #

Represent a RSA public key

Constructors

PublicKey |

Fields

- public_size :: Int

  size of key in bytes

- public_n :: Integer

  public p*q

- public_e :: Integer

  public exponent e

#### Instances

Instances details

Data PublicKey Source # |

Instance details

Defined in Crypto.PubKey.RSA.Types

Methods

gfoldl :: (forall d b. Data d => c (d -> b) -> d -> c b) -> (forall g. g -> c g) -> PublicKey -> c PublicKey Source #

gunfold :: (forall b r. Data b => c (b -> r) -> c r) -> (forall r. r -> c r) -> Constr -> c PublicKey Source #

toConstr :: PublicKey -> Constr Source #

dataTypeOf :: PublicKey -> DataType Source #

dataCast1 :: Typeable t => (forall d. Data d => c (t d)) -> Maybe (c PublicKey) Source #

dataCast2 :: Typeable t => (forall d e. (Data d, Data e) => c (t d e)) -> Maybe (c PublicKey) Source #

gmapT :: (forall b. Data b => b -> b) -> PublicKey -> PublicKey Source #

gmapQl :: (r -> r' -> r) -> r -> (forall d. Data d => d -> r') -> PublicKey -> r Source #

gmapQr :: forall r r'. (r' -> r -> r) -> r -> (forall d. Data d => d -> r') -> PublicKey -> r Source #

gmapQ :: (forall d. Data d => d -> u) -> PublicKey -> [u] Source #

gmapQi :: Int -> (forall d. Data d => d -> u) -> PublicKey -> u Source #

gmapM :: Monad m => (forall d. Data d => d -> m d) -> PublicKey -> m PublicKey Source #

gmapMp :: MonadPlus m => (forall d. Data d => d -> m d) -> PublicKey -> m PublicKey Source #

gmapMo :: MonadPlus m => (forall d. Data d => d -> m d) -> PublicKey -> m PublicKey Source #

Read PublicKey Source # |
Instance details Defined in Crypto.PubKey.RSA.Types Methods readsPrec :: Int -> ReadS PublicKey Source # readList :: ReadS [PublicKey] Source # readPrec :: ReadPrec PublicKey Source # readListPrec :: ReadPrec [PublicKey] Source #
Show PublicKey Source # |
Instance details Defined in Crypto.PubKey.RSA.Types Methods showsPrec :: Int -> PublicKey -> ShowS Source # show :: PublicKey -> String Source # showList :: [PublicKey] -> ShowS Source #
NFData PublicKey Source # |
Instance details Defined in Crypto.PubKey.RSA.Types Methods rnf :: PublicKey -> () Source #
Eq PublicKey Source # |
Instance details Defined in Crypto.PubKey.RSA.Types Methods (==) :: PublicKey -> PublicKey -> Bool Source # (/=) :: PublicKey -> PublicKey -> Bool Source #

data PrivateKey Source #

Represent a RSA private key.

Only the pub, d fields are mandatory to fill.

p, q, dP, dQ, qinv are by-product during RSA generation, but are useful to record here to speed up massively the decrypt and sign operation.

implementations can leave optional fields to 0.

Constructors

PrivateKey |

Fields

- private_pub :: PublicKey

  public part of a private key (size, n and e)

- private_d :: Integer

  private exponent d

- private_p :: Integer

  p prime number

- private_q :: Integer

  q prime number

- private_dP :: Integer

  d mod (p-1)

- private_dQ :: Integer

  d mod (q-1)

- private_qinv :: Integer

  q^(-1) mod p

#### Instances

Instances details

Data PrivateKey Source # |

Instance details

Defined in Crypto.PubKey.RSA.Types

Methods

gfoldl :: (forall d b. Data d => c (d -> b) -> d -> c b) -> (forall g. g -> c g) -> PrivateKey -> c PrivateKey Source #

gunfold :: (forall b r. Data b => c (b -> r) -> c r) -> (forall r. r -> c r) -> Constr -> c PrivateKey Source #

toConstr :: PrivateKey -> Constr Source #

dataTypeOf :: PrivateKey -> DataType Source #

dataCast1 :: Typeable t => (forall d. Data d => c (t d)) -> Maybe (c PrivateKey) Source #

dataCast2 :: Typeable t => (forall d e. (Data d, Data e) => c (t d e)) -> Maybe (c PrivateKey) Source #

gmapT :: (forall b. Data b => b -> b) -> PrivateKey -> PrivateKey Source #

gmapQl :: (r -> r' -> r) -> r -> (forall d. Data d => d -> r') -> PrivateKey -> r Source #

gmapQr :: forall r r'. (r' -> r -> r) -> r -> (forall d. Data d => d -> r') -> PrivateKey -> r Source #

gmapQ :: (forall d. Data d => d -> u) -> PrivateKey -> [u] Source #

gmapQi :: Int -> (forall d. Data d => d -> u) -> PrivateKey -> u Source #

gmapM :: Monad m => (forall d. Data d => d -> m d) -> PrivateKey -> m PrivateKey Source #

gmapMp :: MonadPlus m => (forall d. Data d => d -> m d) -> PrivateKey -> m PrivateKey Source #

gmapMo :: MonadPlus m => (forall d. Data d => d -> m d) -> PrivateKey -> m PrivateKey Source #

Read PrivateKey Source # |
Instance details Defined in Crypto.PubKey.RSA.Types Methods readsPrec :: Int -> ReadS PrivateKey Source # readList :: ReadS [PrivateKey] Source # readPrec :: ReadPrec PrivateKey Source # readListPrec :: ReadPrec [PrivateKey] Source #
Show PrivateKey Source # |
Instance details Defined in Crypto.PubKey.RSA.Types Methods showsPrec :: Int -> PrivateKey -> ShowS Source # show :: PrivateKey -> String Source # showList :: [PrivateKey] -> ShowS Source #
NFData PrivateKey Source # |
Instance details Defined in Crypto.PubKey.RSA.Types Methods rnf :: PrivateKey -> () Source #
Eq PrivateKey Source # |
Instance details Defined in Crypto.PubKey.RSA.Types Methods (==) :: PrivateKey -> PrivateKey -> Bool Source # (/=) :: PrivateKey -> PrivateKey -> Bool Source #

data Blinder Source #

Blinder which is used to obfuscate the timing of the decryption primitive (used by decryption and signing).

Constructors

Blinder !Integer !Integer |

#### Instances

Instances details

Show Blinder Source # |
Instance details Defined in Crypto.PubKey.RSA.Types Methods showsPrec :: Int -> Blinder -> ShowS Source # show :: Blinder -> String Source # showList :: [Blinder] -> ShowS Source #
Eq Blinder Source # |
Instance details Defined in Crypto.PubKey.RSA.Types Methods (==) :: Blinder -> Blinder -> Bool Source # (/=) :: Blinder -> Blinder -> Bool Source #

# Generation function

generateWith Source #

Arguments

:: (Integer, Integer) | chosen distinct primes p and q
-> Int | size in bytes
-> Integer | RSA public exponent `e`
-> Maybe (PublicKey, PrivateKey) |

Generate a key pair given p and q.

p and q need to be distinct prime numbers.

e need to be coprime to phi=(p-1)*(q-1). If that's not the case, the function will not return a key pair. A small hamming weight results in better performance.

- e=0x10001 is a popular choice
- e=3 is popular as well, but proven to not be as secure for some cases.

generate Source #

Arguments

:: MonadRandom m |
=> Int | size in bytes
-> Integer | RSA public exponent `e`
-> m (PublicKey, PrivateKey) |

generate a pair of (private, public) key of size in bytes.

generateBlinder Source #

Arguments

:: MonadRandom m |
=> Integer | RSA public N parameter.
-> m Blinder |

Generate a blinder to use with decryption and signing operation

the unique parameter apart from the random number generator is the public key value N.